#include <fcntl.h>
#include <stdio.h>
#include "port.h"

int main(int argc, char **argv)
{
	int port, i;
	unsigned char regs[10];
	
	port=open("/dev/port",O_RDWR);
	if (!port)
	{
		printf("Unable to open /dev/port!\n");
		return 0;
	}
	wait_w(port);
	out(port,0x3F5,0x0E);
	printf("Command sent\n");
	for(i=0;i<10;i++)
	{
		wait_r(port);
		regs[i]=in(port,0x3F5);
		printf("Read byte %d\n",i);
	}
	printf("\nController's status:\n");
	for(i=0;i<4;i++)
		printf("Current cylinder for drive %d: %d\n",i,regs[i]);
	printf("Step rate interval: %02X\n",regs[4]>>4);
	printf("Head unload time: %02X\n",regs[4] & 0x0F);
	printf("Head load time: %02X\n",regs[5]>>1);
	printf("DMA: %s\n",(regs[5] & 0x01)?"off":"on");
	printf("Sectors per track: %d\n",regs[6]);
	printf("Configuration lock: %s\n",(regs[7]>>7)?"on":"off");
	printf("Perpendicular mode: %02X\n",(regs[7]>>2) & 0x07);
	printf("Alert gap2 lentgh in perpendicular mode: %s\n",((regs[7]>>1) & 0x01)?"on":"off");
	printf("Write gate alert in perpendicular mode: %s\n",(regs[7] & 0x01)?"on":"off");
	printf("Implied seek: %s\n",((regs[8]>>6) & 0x01)?"on":"off");
	printf("Enable FIFO: %s\n",((regs[8]>>5) & 0x01)?"off":"on");
	printf("Enable polling: %s\n",((regs[8]>>4) & 0x01)?"off":"on");
	printf("FIFO threshold: %02X\n",regs[8] & 0x0F);
	printf("Precompensation start track: %d\n",regs[9]);
	close(port);
	return 0;
}
