#include <fcntl.h>
#include <stdio.h>
#include "port.h"

unsigned char buf[512];

void wait_r_quick(int port);

int main(int argc, char **argv)
{
	int port, i;
	unsigned char c, h, s, regs[10], res[7], data, stat;
	
	if (argc<4)
	{
		printf("Usage: seek <cylinder> <head> <sector>\n");
		return 0;
	}
	c=atoi(argv[1]);
	if (c>79)
	{
		printf("Cylinder number is too large!\n");
		return 0;
	}
	h=atoi(argv[2]);
	if (h>1)
	{
		printf("Head can be 0 or 1!\n");
		return 0;
	}
	s=atoi(argv[3]);
	port=open("/dev/port",O_RDWR);
	if (!port)
	{
		printf("Unable to open /dev/port!\n");
		return 0;
	}
	out(port,0x3F2,0x14);
	printf("Determining controller's configuration...\n");
		wait_w(port);
	out(port,0x3F5,0x0E);
	printf("Command sent\n");
	for(i=0;i<10;i++)
	{
		wait_r(port);
		regs[i]=in(port,0x3F5);
		printf("Read byte %d\n",i);
	}
	printf("Sending CONFIGURE command...\n");
	wait_w(port);
	out(port,0x3F5,0x13);
	printf("First byte sent\n");
	wait_w(port);
	out(port,0x3F5,0x00);
	printf("Second byte sent\n");
	wait_w(port);
	out(port,0x3F5,regs[8] | 0x40);
	printf("Third byte sent\n");
	wait_w(port);
	out(port,0x3F5,regs[9]);
	printf("Fourth byte sent\n");
	printf("Sending SPECIFY command...\n");
	wait_w(port);
	out(port,0x3F5,0x03);
	printf("First byte sent\n");
	wait_w(port);
	out(port,0x3F5,regs[4]);
	printf("Second byte sent\n");
	wait_w(port);
	out(port,0x3F5,regs[5] | 0x01);
	printf("Third byte sent\n");
	printf("Sending read command...\n");
	wait_w(port);
	out(port,0x3F5,0x4C);
	printf("First byte sent\n");
	wait_w(port);
	out(port,0x3F5,h<<2);
	printf("Second byte sent\n");
	wait_w(port);
	out(port,0x3F5,c);
	printf("Cylinder number sent\n");
	wait_w(port);
	out(port,0x3F5,h);
	printf("Head number sent\n");
	wait_w(port);
	out(port,0x3F5,s);
	printf("Sector number sent\n");
	wait_w(port);
	out(port,0x3F5,0x02);
	printf("Sector length sent\n");
	wait_w(port);
	out(port,0x3F5,s);
	printf("Final sector number sent\n");
	wait_w(port);
	out(port,0x3F5,0x1B);
	printf("Gap length sent\n");
	wait_w(port);
	out(port,0x3F5,0xFF);
	printf("Special sector size sent\n");
	i=0;
	for(;;)
	{
		wait_r_quick(port);
		data=in(port,0x3F5);
		stat=in(port,0x3F4);
		if (!(stat & 0x20))
			break;
//		printf("Received data byte %d\n",i);
		if (i<512)
		    buf[i]=data;
		i++;
	}
	if (i>512)
		printf("WARNING!!! Extra %d bytes of data received!\n", i-512);
	res[0]=data;
	printf("Read result byte 0\n");
	for(i=1;i<7;i++)
	{
		wait_r(port);
		res[i]=in(port,0x3F5);
		printf("Read result byte %d\n",i);
	}
	printf("Reading complete, restoring previous configuration...\n");
	printf("Sending CONFIGURE command...\n");
	wait_w(port);
	out(port,0x3F5,0x13);
	printf("First byte sent\n");
	wait_w(port);
	out(port,0x3F5,0x00);
	printf("Second byte sent\n");
	wait_w(port);
	out(port,0x3F5,regs[8]);
	printf("Third byte sent\n");
	wait_w(port);
	out(port,0x3F5,regs[9]);
	printf("Fourth byte sent\n");
	printf("Sending SPECIFY command...\n");
	wait_w(port);
	out(port,0x3F5,0x03);
	printf("First byte sent\n");
	wait_w(port);
	out(port,0x3F5,regs[4]);
	printf("Second byte sent\n");
	wait_w(port);
	out(port,0x3F5,regs[5]);
	printf("Third byte sent\n");
	printf("\nRead operation result:\n");
	for (i=0;i<3;i++)
		printf("Status register %d: %02X\n",i,res[i]);
	printf("Current cylinder: %d\n", res[3]);
	printf("Current head: %d\n", res[4]);
	printf("Current sector: %d\n", res[5]);
	printf("Sector length: %d\n", res[6]);
	sleep(1);
	out(port,0x3F2,0x04);
	close(port);
	port=open("sector.dat",O_WRONLY|O_CREAT);
	if(port)
	{
		write(port,buf,512);
		close(port);
	}
	else
		printf("Unable to open output file!\n");
	return 0;
}

void wait_r_quick(int port)
{
	unsigned char s;

	do
		s=in(port,0x3F4);
	while ((s & 0xC0) != 0xC0);
}
