#include <fcntl.h>
#include <stdio.h>
#include "port.h"

void wait_w(int port);
void wait_r(int port);

int main()
{
	int port, l;
	unsigned char st0, pcn;

	port=open("/dev/port",O_RDWR);
	if (!port)
	{
		printf("Unable to open /dev/port!\n");
		return 0;
	}
	out(port,0x3F2,0x14);
	usleep(100000);
	wait_w(port);
	out(port,0x3F5,0x07);
	printf("First byte sent\n");
	wait_w(port);
	out(port,0x3F5,0x00);
	printf("Second byte sent\n");
	do
	{
		wait_w(port);
		out(port,0x3F5,0x08);
		printf("Sense interrupt status sent\n");
		wait_r(port);
		st0=in(port,0x3F5);
		printf("Read status register 0: %02X\n",st0);
	}
	while(st0 == 0x80);
	printf("Operation complete\n");
	wait_r(port);
	pcn=in(port,0x3F5);
	printf("Current track number: %d\n",pcn);
	sleep(1);
	out(port,0x3F2,0x04);
	close(port);
	return 0;
}
