#include <fcntl.h>
#include <stdio.h>
#include "port.h"

int main(int argc, char **argv)
{
	int port, l;
	unsigned char cyl, st0, pcn;
	
	if (argc<2)
	{
		printf("Usage: seek <track number>\n");
		return 0;
	}
	cyl=atoi(argv[1]);
	if (cyl>79)
	{
		printf("Cylinder number is too large!\n");
		return 0;
	}
	port=open("/dev/port",O_RDWR);
	if (!port)
	{
		printf("Unable to open /dev/port!\n");
		return 0;
	}
	out(port,0x3F2,0x14);
	usleep(100000);
	wait_w(port);
	out(port,0x3F5,0x0F);
	printf("First byte sent\n");
	wait_w(port);
	out(port,0x3F5,0x00);
	printf("Second byte sent\n");
	wait_w(port);
	out(port,0x3F5,cyl);
	printf("Cylinder number sent\n");
	do
	{
		wait_w(port);
		out(port,0x3F5,0x08);
		printf("Sense interrupt status sent\n");
		wait_r(port);
		st0=in(port,0x3F5);
		printf("Read status register 0: %02X\n",st0);
	}
	while(st0 == 0x80);
	printf("Operation complete\n");
	wait_r(port);
	pcn=in(port,0x3F5);
	printf("Current track number: %d\n",pcn);
	sleep(1);
	out(port,0x3F2,0x04);
	close(port);
	return 0;
}
